/*  n_free_neuron.c */

/* 	Copyright 2004-2006 Oswaldo Morizaki Hirakata */

/* 	This file is part of ga-nn-ag.

    ga-nn-ag is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn-ag is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn-ag; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "my_header.h"
#include "aux_prot.h"

void * n_free_neuron(struct neuron * neuron1)
{
	int k;
	if (neuron1 == NULL)
	{
		return(NULL);
	}
	
	if (neuron1->num_con > 0)
	{
		if (neuron1->con != NULL)
		{
			for (k=0; k< neuron1->num_con; k++)
			{
				if (neuron1->con[k] != NULL)
				{
					if (neuron1->momentum > 0)
					{
						if (neuron1->con[k]->delta_weight != NULL)
						{
							free(neuron1->con[k]->delta_weight);
							neuron1->con[k]->delta_weight = NULL;
						}
					}
					if (neuron1->con[k]->con_x != NULL)
					{
						free(neuron1->con[k]->con_x);
					}
					free(neuron1->con[k]);
				}
			}
		}
		free(neuron1->con);
	}
	if (neuron1->momentum > 0)
	{
		if (neuron1->alpha != NULL)
		{
			free(neuron1->alpha);
		}
	}
	if (neuron1->range != NULL)
	{
		free(neuron1->range);
	}
	if (neuron1->x_c != NULL)
	{
		free(neuron1->x_c);
	}
	free(neuron1);
	neuron1 = NULL;
	return(neuron1);
}
